All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.metadata.remote
Interface PrototypeProperty

All Superinterfaces:
  AbstractProperty, CMetadata, LocalizedType, MdObjectBase, MdObjectBaseUtil, MdObjectBaseXML, java.rmi.Remote, Root, SecondaryType

All Known Subinterfaces:
  AssociationProperty, AttributeProperty

    public interface PrototypeProperty

extends AbstractProperty

This is the super type for types that define properties that are for prototype objects only. These are either AttributeProperty or AssociationProperty objects.

Attributes of PrototypeProperty are:

Associations of PrototypeProperty are:

- `OwningPrototype`

## Usage

To create an instance of this PrototypeProperty, use the `factory` create methods.
Example: create a PrototypeProperty with name "PrototypeProperty_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     PrototypeProperty myObject = (PrototypeProperty) factory.createComplexMetadataObject(objectStore, "PrototypeProperty_Object", MetadataObjects.PROTOTYPEPROPERTY, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

Field Summary
`static java.lang.String` | `ASSOCIATION_OWNINGPROTOTYPE_NAME` Constant used for the name of the OwningPrototype association.

Fields inherited from interface com.sas.metadata.remote.AbstractProperty
`ASSOCIATION_ASSOCIATEDPROPERTYGROUP_NAME, ASSOCIATION_CUSTOMIZERS_NAME, ASSOCIATION_EDITORS_NAME, ASSOCIATION_STOREDCONFIGURATION_NAME, ASSOCIATION_VALIDATORS_NAME, ATTRIBUTE_ISEXPERT_NAME, ATTRIBUTE_ISLINKED_NAME, ATTRIBUTE_ISREQUIRED_NAME, ATTRIBUTE_ISUPDATEABLE_NAME, ATTRIBUTE_ISVISIBLE_NAME`

Fields inherited from interface com.sas.metadata.remote.LocalizedType
`ASSOCIATION_RESOURCES_NAME`

Fields inherited from interface com.sas.metadata.remote.Root
`ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

Fields inherited from interface com.sas.metadata.remote.MdObjectBase
`ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

Method Summary
`Prototype` | `getOwningPrototype()` Gets the `Prototype` for `OwningPrototype`
`AssociationList` | `getOwningPrototypes()` Gets the Association list of `OwningPrototypes`
`AssociationList` | `getOwningPrototypes(boolean fGoToServer)` Gets the Associationlist of `OwningPrototypes`
`void` | `initializePredObjects()` (S) Adds the Associated objects to the predObjects which are:
`void` | `initializeRequiredObjects()` (S) This initializes the Required Objects(Roles) which are: `OwningPrototype`
`void` | `setOwningPrototype(Prototype inObject)` Sets the `OwningPrototypes` list 0th element to be `inObject`.
`void` | `setOwningPrototypes(AssociationList list)` Sets the `OwningPrototypes` list to be `list`.
`void` | `setOwningPrototypes(AssociationList list, int state)` Sets the `OwningPrototypes` list to be `list`.

Methods inherited from interface com.sas.metadata.remote.AbstractProperty
`getAssociatedPropertyGroup, getAssociatedPropertyGroups, getAssociatedPropertyGroups, getCustomizers, getCustomizers, getEditors, getEditors, getIsExpert, getIsExpertState, getIsLinked, getIsLinkedState, getIsRequired, getIsRequiredState, getIsUpdateable, getIsUpdateableState, getIsVisible, getIsVisibleState, getStoredConfiguration, getStoredConfigurations, getStoredConfigurations, getValidators, getValidators, setAssociatedPropertyGroup, setAssociatedPropertyGroups, setAssociatedPropertyGroups, setCustomizers, setCustomizers, setEditors, setEditors, setIsExpert, setIsExpert, setIsExpert, setIsExpert, setIsExpertState, setIsLinked, setIsLinked, setIsLinked, setIsLinked, setIsLinkedState, setIsRequired, setIsRequired, setIsRequired, setIsRequired, setIsRequiredState, setIsUpdateable, setIsUpdateable, setIsUpdateable, setIsUpdateable, setIsUpdateableState, setIsVisible, setIsVisible, setIsVisible, setIsVisible, setIsVisibleState, setStoredConfiguration, setStoredConfigurations, setStoredConfigurations, setValidators, setValidators`

Methods inherited from interface com.sas.metadata.remote.LocalizedType
`getResources, getResources, setResources, setResources`

Methods inherited from interface com.sas.metadata.remote.Root
`getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML
`closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil
`addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

Methods inherited from interface com.sas.metadata.remote.MdObjectBase
`addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

Field Detail

### ASSOCIATION_OWNINGPROTOTYPE_NAME

    static final java.lang.String ASSOCIATION_OWNINGPROTOTYPE_NAME

  Constant used for the name of the OwningPrototype association.

  OwningPrototype: The prototype that owns these properties.

  See Also:
    Constant Field Values

Method Detail

### initializeRequiredObjects

    void initializeRequiredObjects()
                                   throws java.rmi.RemoteException

  (S) This initializes the Required Objects(Roles) which are:
  `OwningPrototype`

  Specified by:
    `initializeRequiredObjects` in interface `AbstractProperty`
  Specified by:
    `initializeRequiredObjects` in interface `LocalizedType`
  Specified by:
    `initializeRequiredObjects` in interface `MdObjectBaseUtil`
  Specified by:
    `initializeRequiredObjects` in interface `Root`
  Specified by:
    `initializeRequiredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### initializePredObjects

    void initializePredObjects()
                               throws java.rmi.RemoteException

  (S) Adds the Associated objects to the predObjects which are:

  Specified by:
    `initializePredObjects` in interface `AbstractProperty`
  Specified by:
    `initializePredObjects` in interface `LocalizedType`
  Specified by:
    `initializePredObjects` in interface `MdObjectBase`
  Specified by:
    `initializePredObjects` in interface `Root`
  Specified by:
    `initializePredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getOwningPrototypes

    AssociationList getOwningPrototypes()
                                        throws java.rmi.RemoteException,
                                               MdException

  Gets the Association list of `OwningPrototypes`

  Returns:
    The AssociationList of `OwningPrototypes` which can be of type:
    Prototype
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### getOwningPrototype

    Prototype getOwningPrototype()
                                 throws java.rmi.RemoteException,
                                        MdException

  Gets the `Prototype` for `OwningPrototype`

  Returns:
    The `Prototype` ( `null` if not set ) of `OwningPrototype` which can be of type:
    Prototype
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### getOwningPrototypes

    AssociationList getOwningPrototypes(boolean fGoToServer)
                                        throws java.rmi.RemoteException,
                                               MdException

  Gets the Associationlist of `OwningPrototypes`

  Parameters:
    `fGoToServer` - boolean Get the value from the server.
  Returns:
    Returns the `OwningPrototypes` which can be of type:
    Prototype
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### setOwningPrototypes

    void setOwningPrototypes(AssociationList list)
                             throws java.rmi.RemoteException

  Sets the `OwningPrototypes` list to be `list`. Objects of which can be of type:
  Prototype

  Parameters:
    `list` - AssociationList
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setOwningPrototypes

    void setOwningPrototypes(AssociationList list,
                             int state)
                             throws java.rmi.RemoteException

  Sets the `OwningPrototypes` list to be `list`. Objects of which can be of type:
  Prototype

  Parameters:
    `list` - AssociationList
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setOwningPrototype

    void setOwningPrototype(Prototype inObject)
                            throws java.rmi.RemoteException

  Sets the `OwningPrototypes` list 0th element to be `inObject`.

  Parameters:
    `inObject` - Prototype
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.